local PetBattleTeams = LibStub("AceAddon-3.0"):GetAddon("PetBattleTeams")
local TeamManager =  PetBattleTeams:GetModule("TeamManager")
local GUI = PetBattleTeams:GetModule("GUI")
local ROW_HEIGHT = 40
local PETS_PER_TEAM = 3
local MAX_ROWS = 12


local function Update(self)
	local numToDisplay = math.max(math.ceil(self:GetHeight() / ROW_HEIGHT) , 4)
	local numItems = TeamManager:GetNumTeams()
	local offset = FauxScrollFrame_GetOffset(self)
	
	FauxScrollFrame_Update(self, numItems, numToDisplay, ROW_HEIGHT,nil, nil, nil, nil, nil, nil, true)  
	local teamFrames = self.scrollChild.teamFrames
	
	for i=1,#teamFrames do
		teamFrames[i]:SetTeam(i+offset)
	end
end

local function OnShow(self)
	Update(self)
end

local function OnVerticalScroll(self,offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, ROW_HEIGHT, Update);
end

local function OnSizeChanged(self,width,height)
	local numToDisplay = math.max(math.ceil(self:GetHeight() / ROW_HEIGHT) , 4)
	local teamFrames = self.scrollChild.teamFrames
	local numTeams = TeamManager:GetNumTeams()
	
	for i=1,#teamFrames do
		if i < numToDisplay and i <= numTeams then
			teamFrames[i]:Show()
		else
			teamFrames[i]:Hide()
		end
	end
	
	Update(self)
end

function GUI:CreateScrollBar(parent)
	local name = "PetBattleTeamsScrollFrame"
	frame = CreateFrame("ScrollFrame",name,parent,"FauxScrollFrameTemplate")
	frame:EnableMouse(true)
	frame:SetScript("OnVerticalScroll",OnVerticalScroll)
	frame:SetScript("OnShow",OnShow)
	frame:SetScript("OnSizeChanged",OnSizeChanged)
	frame:Show()
	
	local scrollChild = CreateFrame("frame",nil,parent)
	frame.scrollChild = scrollChild
	
	
	scrollChild.teamFrames = {}
	local team = PetBattleTeamsFrame:New()
	team:SetPoint("TOPLEFT",scrollChild,"TOPLEFT",20,-3)
	team:SetTeam(1)
	team:SetParent(scrollChild)
	scrollChild.teamFrames[1] = team
	
	for i=2, MAX_ROWS do
		team = PetBattleTeamsFrame:New()
		team:SetPoint("TOPLEFT",scrollChild.teamFrames[i-1],"BOTTOMLEFT")
		team:SetParent(scrollChild)
		team:SetTeam(i)
		scrollChild.teamFrames[i] = team
	end
	
	scrollChild:Show()
	
	local width,height = team:GetSize()
	scrollChild:SetAllPoints(frame)
	scrollChild:SetParent(parent)
	function frame:TEAM_DELETED() Update(self) OnSizeChanged(self) self:GetParent():SnapToSize() end
	frame.TEAM_CREATED =  frame.TEAM_DELETED
	
	
	TeamManager.RegisterCallback(frame,"TEAM_DELETED")
	TeamManager.RegisterCallback(frame,"TEAM_CREATED")
	Update(frame)
	return frame
end

function GUI:CreateTeamsFrame(parent)
	return scrollChild
end